<?php
/*
Plugin Name: Booking Live Plugin
Plugin URI: http://wordpress.org/plugins/bookinglive/
Description: Connects WordPress to BookingLive System.
Author: BookingLive.
Author URI: http://www.bookinglive.com
Version: 0.8
*/
if ( ! defined( 'WP_PLUGIN_URL' ) ) define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );


function bookingLive_settings() {

    register_setting('bookingLive','bookingLive_siteHost_name','bookingLive_valid_host');
	register_setting('bookingLive','bookingLive_hide_Header');
	register_setting('bookingLive','bookingLive_hide_Footer');
	register_setting('bookingLive','bookingLive_hide_Widgets');

}

add_action('admin_init', 'bookingLive_settings');

function your_plugin_settings_link($links) {
	$settings_link = '<a href="options-general.php?page=BookingLive_Options">Settings</a>';
	array_unshift($links, $settings_link);
	return $links;
}

$plugin = plugin_basename(__FILE__);
add_filter("plugin_action_links_$plugin", 'your_plugin_settings_link',10,2);



add_action( 'admin_menu', 'BookingLive_menu' );


function BookingLive_menu() {
	add_options_page( 'BookingLive Settings', 'BookingLive', 'manage_options', 'BookingLive_Options', 'bookingLive_options' );
}


add_filter('sidebars_widgets', 'hidemywidget');

function hidemywidget($all_widgets){
	$id = get_the_ID();
	$metaActivity = get_post_meta( $id, "ActivityList",true);
	$metaPage = get_post_meta( $id, "PageList",true);
	$metaExtra =  get_post_meta( $id, "ExtraList",true);
	if($metaActivity!="" || $metaExtra!="" || $metaPage!=""){
		if(get_option("bookingLive_hide_Widgets")==""){
			?>
			<style>
				.widget-area{
					display: none;
				}
				#content{
					width: 100%;
				}
			</style>
			<?php
			return "";
		}
	}
	return $all_widgets;
}

function bookingLive_options() {
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}
	echo '<div class="wrap">';
	echo '<p><h2>BookingLive Settings</h2></p>';
	echo 'BookingLive Plugin by  <a href="http://www.bookinglive.com" target="_blank" >BookingLive</a> | <a href="http://bookinglive.com/help" >Documentation</a></br></br>';
	echo '<form method="post" action="options.php">';
	settings_fields( 'bookingLive' );
	do_settings_sections( 'bookingLive' );
	echo '<label for="bookingLive_siteHost_name" ><b>Enter your BookingLive URL : </b></label><input type="text" name="bookingLive_siteHost_name" value="'.get_option('bookingLive_siteHost_name').'" /> <i>eg : http://demo.bookinglive.com</i></br></br>';
	$hideHeaderChecked="";

	if(get_option('bookingLive_hide_Header',"")=="on"){
		$hideHeaderChecked ="checked";
	}
	$hideFooterChecked="";
	if(get_option('bookingLive_hide_Footer',"")=="on" ){
		$hideFooterChecked="checked";
	}
	$hideWidgets="";
	if(get_option("bookingLive_hide_Widgets","")=="on"){
		$hideWidgets="checked";
	}
	echo '<label for="bookingLive_hide_Header" ><b>Show BookingLive Header : </b></label><input type="checkbox" name="bookingLive_hide_Header" '.$hideHeaderChecked.' />';
	echo '<label for="bookingLive_hide_Footer" ><b>Show BookingLive Footer : </b></label><input type="checkbox" name="bookingLive_hide_Footer" '.$hideFooterChecked.' />';
	echo '</br></br><label for="bookingLive_hide_Widgets"><b>Show sideBar and widgets : </b></label><input type="checkbox" name="bookingLive_hide_Widgets" '.$hideWidgets.' />';
	submit_button();
	echo '</form>';
	echo '</div>';

}



function bookingLive_getIframe($type,$id){
	$returnIframe="";
	$hideHeader = esc_attr(get_option('bookingLive_hide_Header'));
	if($hideHeader==""){
		$hideHeader="on";
	}
	else{
		$hideHeader="off";
	}
	$hideFooter = esc_attr(get_option('bookingLive_hide_Footer'));
	if($hideFooter==""){
		$hideFooter="on";
	}
	else{
		$hideFooter="off";
	}
	if($type=="Activity"){
		$returnIframe='<div id="bookinglive-embedded-iframe"></div>
					   <script type="text/javascript">
                           var bl_iframe = {
                                activity_id : '.esc_attr($id).',
                                install : "'.esc_attr(get_option('bookingLive_siteHost_name')).'/",
								HideHeader : "'.$hideHeader.'",
								HideFooter : "'.$hideFooter.'"
                           };
					   </script>';
	}
	else if($type=='URL'){
		$returnIframe='<div id="bookinglive-embedded-iframe"></div>
					   <script type="text/javascript">
					        var bl_iframe = {
					            src : "'.esc_attr(get_option('bookingLive_siteHost_name')).'/'.esc_attr($id).'",
					            install : "'.esc_attr(get_option('bookingLive_siteHost_name')).'/",
					            HideHeader : "'.$hideHeader.'",
								HideFooter : "'.$hideFooter.'"
                            };
                        </script>';
	}
	else if($type=='Extra'){

		$returnIframe='<div id="bookinglive-embedded-iframe"></div>
					   <script type="text/javascript">
					        var bl_iframe = {
					            extra_id : '.esc_attr($id).',
					            install : "'.esc_attr(get_option('bookingLive_siteHost_name')).'/",
					            HideHeader : "'.$hideHeader.'",
								HideFooter : "'.$hideFooter.'"
                            };
                        </script>';
	}
	else{
		$returnIframe='<div id="bookinglive-embedded-iframe"></div>
					   <script type="text/javascript">
					        var bl_iframe = {
					            src : "'.esc_attr(get_option('bookingLive_siteHost_name')).'/",
					            install : "'.esc_attr(get_option('bookingLive_siteHost_name')).'/",
					            HideHeader : "'.$hideHeader.'",
								HideFooter : "'.$hideFooter.'"
                            };
                        </script>';
	}

	$returnIframe .= '<script src="'.get_option('bookingLive_siteHost_name').'/mysite/javascript/embedded-iframe/iframe-embed.js"></script>';

	return $returnIframe;
}


function bookingLive_valid_host($input) {

    $newInput=$input;
    if(!preg_match('~^http://|https://~',$newInput)) $newInput = 'http://' . $newInput;

	$responseCode = wp_remote_retrieve_response_code(wp_remote_head($newInput));
    if(!$responseCode || ($responseCode != 200 && $responseCode != 302)) {
        add_settings_error( 'bookingLive_siteHost_name', esc_attr( 'settings_updated' ),'Error: Could not connect to the host URL <br />Returned status: '.$responseCode);
        $newInput='';
        return $newInput;
    }
    else{

	    $arrCurlReturn = wp_remote_post( 'http://www.bookinglive.com/CheckUrl', array(
			    'method' => 'POST',
			    'timeout' => 45,
			    'redirection' => 5,
			    'httpversion' => '1.0',
			    'blocking' => true,
			    'headers' => array(),
			    'body' => array( 'URL' => $newInput),
			    'cookies' => array()
		    )
	    );
        if(is_wp_error($arrCurlReturn)){
            add_settings_error( 'bookingLive_siteHost_name', esc_attr( 'settings_updated' ),$arrCurlReturn['error']);
        }
        else{
            if($arrCurlReturn['body']=='false'){
                add_settings_error( 'bookingLive_siteHost_name', esc_attr( 'settings_updated' ),'Error: Unable to register wih host site');
            }
            else{
                return $newInput;
            }
        }
    }
}

add_action( 'add_meta_boxes', 'BookingLiveContent' );

function BookingLiveContent() {
	add_meta_box(
		'BookingLiveContent_id',
		'BookingLive content',
		'BookingLiveContent_content',
		'page',
		'normal',
		'default'
	);
}



function BookingLiveContent_content( $post ) {
	?>
	<script type="text/javascript" >
		jQuery(document).ready(function($) {
			var value = $("#TypeOfList").val();
			var PostID = $("#PostID").val();
			var data = {
				action: 'my_action',
				type : value,
				postID : PostID

			};
			$.post(ajaxurl, data, function(response) {
				$("#Field_content").html(response);
			});
			$("#TypeOfList").change(function(){
				var value = $(this).val();
				var PostID = $("#PostID").val();
				var data = {
					action: 'my_action',
					type : value,
					postID : PostID

				};
				$.post(ajaxurl, data, function(response) {
					$("#Field_content").html(response);
				});
			});

		});
	</script>
	<?php
	$strOptions="";
	$metaActivity = get_post_meta( $post->ID, "ActivityList",true);
	$metaPage = get_post_meta( $post->ID, "PageList",true);
	$metaExtra =  get_post_meta( $post->ID, "ExtraList",true);
	if($metaActivity!=""){
		$strOptions .='<option value="1" selected>Activity</option>';
	}
	else{
		$strOptions .='<option value="1">Activity</option>';
	}
	if($metaExtra!=""){
		$strOptions .='<option value="2" selected>Extra</option>';
	}
	else{
		$strOptions .='<option value="2">Extra</option>';
	}
	if($metaPage!=""){
		$strOptions.= '<option value="3" selected>Page</option>';
	}
	else{
		$strOptions .='<option value="3">Page</option>';
	}

	$strReturn='<select name="TypeOfList" id="TypeOfList" >
				<option value="0" >Please select the type of content you want to display</option>'
				.$strOptions.'
				</select>';
	$strReturn .='<div id="Field_content"></div>';
	$strReturn .='<br/><br/>Remove all BookingLive Content on this page <input type="checkbox" name="RemoveContent" >';
	$strReturn .='<input type="hidden" id="PostID" value="'.$post->ID.'" >';
	wp_nonce_field( plugin_basename( __FILE__ ), 'myplugin_nonce' );
	echo $strReturn;
}

add_action( 'wp_ajax_my_action', 'my_action_callback' );

function my_action_callback() {
	global $wpdb; // this is how you get access to the database

	if(isset($_POST['type']) && isset($_POST["postID"])){
		$postID = $_POST["postID"];
		$type = $_POST["type"];
		$strReturn="";
		if($type == "1"){
			$arrCurlReturn = wp_remote_post( esc_attr(get_option('bookingLive_siteHost_name')).'/XMLPage_Controller/ActivityList', array(
					'method' => 'POST',
					'timeout' => 45,
					'redirection' => 5,
					'httpversion' => '1.0',
					'blocking' => true,
					'headers' => array(),
					'cookies' => array()
				)
			);
			$strOptions="";
			$arrActivities = json_decode($arrCurlReturn["body"]);
			$meta_values = get_post_meta( $postID, "ActivityList",true);
			if($arrActivities)foreach($arrActivities as $Activity){
				$selected="";
				if($meta_values == $Activity->ID){
					$selected="selected";
				}
				$strOptions.='<option value="'.$Activity->ID.'" '.$selected.' >'.$Activity->Name.'</option>';
			}
			$strReturn = '<select name="ActivityList" ><option value="0">Please select an Activity</option>'.$strOptions.'</select>';
		}
		if($type == "2"){
			$arrCurlReturn = wp_remote_post( esc_attr(get_option('bookingLive_siteHost_name')).'/XMLPage_Controller/ExtraList', array(
					'method' => 'POST',
					'timeout' => 45,
					'redirection' => 5,
					'httpversion' => '1.0',
					'blocking' => true,
					'headers' => array(),
					'cookies' => array()
				)
			);
			$strOptions="";
			$arrExtras = json_decode($arrCurlReturn["body"]);
			$meta_values = get_post_meta( $postID, "ExtraList",true);
			if($arrExtras)foreach($arrExtras as $Extra){
				$selected="";
				if($meta_values == $Extra->ID){
					$selected="selected";
				}
				$strOptions.='<option value="'.$Extra->ID.'" '.$selected.' >'.$Extra->Name.'</option>';
			}
			$strReturn = '<select name="ExtraList" ><option value="0">Please select an Extra</option>'.$strOptions.'</select>';
		}
		if($type == "3"){
			$arrCurlReturn = wp_remote_post( esc_attr(get_option('bookingLive_siteHost_name')).'/XMLPage_Controller/PageList', array(
					'method' => 'POST',
					'timeout' => 45,
					'redirection' => 5,
					'httpversion' => '1.0',
					'blocking' => true,
					'headers' => array(),
					'cookies' => array()
				)
			);
			$strOptions="";
			$arrPages = json_decode($arrCurlReturn["body"]);
			$meta_values = get_post_meta( $postID, "PageList",true);
			if($arrPages)foreach($arrPages as $Page){
				$selected="";
				if($meta_values == $Page->ID){
					$selected="selected";
				}
				$strOptions.='<option value="'.$Page->ID.'" '.$selected.' >'.$Page->Name.'</option>';
			}
			$strReturn = '<select name="PageList" ><option value="0">Please select a Page</option>'.$strOptions.'</select>';
		}
		echo $strReturn;
	}
	die(); // this is required to return a proper result
}


add_action( 'save_post', 'customFields_data' );

function customFields_data() {

	if (isset($_POST["ActivityList"]) && $_POST["ActivityList"]!="0" ){
		update_post_meta($_POST["ID"], 'ActivityList', $_POST["ActivityList"]);
		delete_post_meta($_POST["ID"],'ExtraList');
		delete_post_meta($_POST["ID"],'PageList');
	}
	if(isset($_POST["ExtraList"]) && $_POST["ExtraList"]!="0" ){
		update_post_meta($_POST["ID"],'ExtraList',$_POST["ExtraList"]);
		delete_post_meta($_POST["ID"],'ActivityList');
		delete_post_meta($_POST["ID"],'PageList');
	}
	if(isset($_POST["PageList"]) && $_POST["PageList"]!="0" ){
		update_post_meta($_POST["ID"],"PageList",$_POST["PageList"]);
		delete_post_meta($_POST["ID"],'ActivityList');
		delete_post_meta($_POST["ID"],'ExtraList');
	}
	if(isset($_POST["RemoveContent"])){
		delete_post_meta($_POST["ID"],'ActivityList');
		delete_post_meta($_POST["ID"],'ExtraList');
		delete_post_meta($_POST["ID"],'PageList');
	}


}

function my_the_post_action( $content ) {
	global $post;
	$metaPage = get_post_meta( $post->ID, "PageList",true);
	if($metaPage!="" && $metaPage!="0"){
		$iFrame = bookingLive_getIframe("URL",$metaPage);
		$content.= $iFrame;
		$content.='Powered by <a href="http://www.bookinglive.com" target="_blank" >BookingLive</a>';
	}
	$metaActivity = get_post_meta( $post->ID, "ActivityList",true);
	if($metaActivity!="" && $metaActivity!="0"){
		$iFrame = bookingLive_getIframe("Activity",$metaActivity);
		$content.= $iFrame;
		$content.='Powered by <a href="http://www.bookinglive.com" target="_blank" >BookingLive</a>';

	}
	$metaExtra = get_post_meta( $post->ID, "ExtraList",true);
	if($metaExtra!="" && $metaExtra!="0"){
		$iFrame = bookingLive_getIframe("Activity",$metaExtra);
		$content.= $iFrame;
		$content.='Powered by <a href="http://www.bookinglive.com" target="_blank" >BookingLive</a>';
	}
	return $content;
}
add_action( 'the_content', 'my_the_post_action' );


?>